<?php
/*
#########################################################
##############   openPlaG 2.1: graph.php   ##############
#########################################################
#############   written by Juergen Kummer   #############
#########################################################
##############   published under GNU GPL   ##############
#########################################################
Original source: http://rechneronline.de/function-graphs/
#########################################################
Copyright (C) 2008 Juergen Kummer

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

/*
This file draws the image and displays it.
*/

// deny access on the generated image from external urls
// you do not need to do that, but I recommend it
// please change the path name to the one desired
/*

if($HTTP_REFERER!="http://allowed_domain.org/" && $HTTP_REFERER!="http://www.allowed_domain.org/")

	die();

*/

// read the query string and give the variables their old name 
$c=$_GET['a0'];
$formula1=$_GET['a1'];
$formula2=$_GET['a2'];
$formula3=$_GET['a3'];
$col1=$_GET['a4'];
$col2=$_GET['a5'];
$col3=$_GET['a6'];
$term1=$_GET['a7'];
$term2=$_GET['a8'];
$term3=$_GET['a9'];
$width=$_GET['b0'];
$height=$_GET['b1'];
$rulex1=$_GET['b2'];
$rulex2=$_GET['b3'];
$ruley1=$_GET['b4'];
$ruley2=$_GET['b5'];
$intervalsx=$_GET['b6'];
$intervalsy=$_GET['b7'];
$linex=$_GET['b8'];
$liney=$_GET['b9'];
$deci=$_GET['c0'];
$mid=$_GET['c1'];
$lines=$_GET['c2'];
$numbers=$_GET['c3'];
$dashes=$_GET['c4'];
$frame=$_GET['c5'];
$errors=$_GET['c6'];
$sint1=$_GET['c7'];
$sint2=$_GET['c8'];
$sint3=$_GET['c9'];
$grid=$_GET['d0'];
$gridx=$_GET['d1'];
$gridy=$_GET['d2'];
$logsk=$_GET['d3'];
$ta1=$_GET['d4'];
$ta2=$_GET['d5'];
$tb1=$_GET['d6'];
$tb2=$_GET['d7'];
$tc1=$_GET['d8'];
$tc2=$_GET['d9'];
$cint1=$_GET['e0'];
$cint2=$_GET['e1'];
$cint3=$_GET['e2'];
$qq=$_GET['e3'];
$bg=$_GET['e4'];
$gapc=$_GET['e5'];
$capt=$_GET['e6'];
$linec=$_GET['e7'];
$con0=$_GET['e8'];
$con1=$_GET['e9'];
$con2=$_GET['f0'];
$anti=$_GET['f1'];
$gamma=$_GET['f2'];
$bri=$_GET['f3'];
$cont=$_GET['f4'];
$emb=$_GET['f5'];
$blur=$_GET['f6'];
$neg=$_GET['f7'];
$gray=$_GET['f8'];
$mean=$_GET['f9'];
$edge=$_GET['g0'];
$bf=$_GET['g1'];
$pol=$_GET['g2'];
$rotate=$_GET['g3'];
$filetype=$_GET['g4'];

// initial values for the display
if (!$c) {
	$formula1='x^2';//start value for formula 1
	$col1=1;//color 1
	$term1=1;//show term 1
	$term2="";//don't show term 2
	$term3="";//don't show term 3
	$sint1=0;//integral, derivative or f(x) of function 1
	$width=500;//image width
	$height=500;//image height
	$rulex1=-5;//x left
	$ruley1=-5;//y bottom
	$rulex2=5;//x right
	$ruley2=5;//y top
	$intervalsx=10;//number of x-intervals
	$intervalsy=10;//number of y-intervals
	$gridx=20;//number of x reticule lines
	$gridy=20;//number of y reticule lines
	$linex=5;//length x dashes
	$liney=5;//length y dashes
	$mid=0;//gap at origin
	$deci=3;//decimal places
	$lines=1;//axis lines yes
	$grid=1;//reticule lines yes
	$numbers=1;//caption yes
	$dashes=1;//dashes yes
	$frame=1;//frame yes
	$errors=1;//show errors yes
	$logsk=0;//logarithmic scale no
	$bg=14;//white background
	$gapc=14;//white gap
	$capt=13;//black caption
	$linec=12;//grey reticule lines
	$con0=0;//connect dots
	$con1=0;//connect dots
	$con2=0;//connect dots
	$anti=1;//antialiasing yes
	$gamma=1;//no gamma correction
	$bri=0;//normal brightness
	$cont=0;//normal contrast
	$bf=1;//lines in background
	$pol=1;//find poles
	$rotate=0;//no rotation
	$filetype=0;//output as png image
}

// set file type
if($filetype==1)
	Header ("Content-type: image/gif");
else if($filetype==2)
	Header ("Content-type: image/jpeg");
else
	Header ("Content-type: image/png");

// use constants as overall range
$rulex1=str_replace('pi',M_PI,$rulex1);
$rulex1=str_replace('e',M_E,$rulex1);
$rulex1=str_replace('sq2',M_SQRT2,$rulex1);
$rulex1=str_replace('go','1.6180339887499',$rulex1);
$rulex1=str_replace('d','4.669201609103',$rulex1);
$ruley1=str_replace('pi',M_PI,$ruley1);
$ruley1=str_replace('e',M_E,$ruley1);
$ruley1=str_replace('sq2',M_SQRT2,$ruley1);
$ruley1=str_replace('go','1.6180339887499',$ruley1);
$ruley1=str_replace('d','4.669201609103',$ruley1);
$rulex2=str_replace('pi',M_PI,$rulex2);
$rulex2=str_replace('e',M_E,$rulex2);
$rulex2=str_replace('sq2',M_SQRT2,$rulex2);
$rulex2=str_replace('go','1.6180339887499',$rulex2);
$rulex2=str_replace('d','4.669201609103',$rulex2);
$ruley2=str_replace('pi',M_PI,$ruley2);
$ruley2=str_replace('e',M_E,$ruley2);
$ruley2=str_replace('sq2',M_SQRT2,$ruley2);
$ruley2=str_replace('go','1.6180339887499',$ruley2);
$ruley2=str_replace('d','4.669201609103',$ruley2);
if(!is_numeric($rulex1) || !is_numeric($rulex2) || !is_numeric($ruley1) || !is_numeric($ruley2))
	die(); //security check before eval
eval('$rulex1 = $rulex1;');
eval('$rulex2 = $rulex2;');
eval('$ruley1 = $ruley1;');
eval('$ruley2 = $ruley2;');

$sum=0; //addition variable for phi
$iter=''; //last value for iteration
$iter2=''; //one before last value for iteration
$istep=0; //counter for iteration steps
$average=0; //memory for arithmetic mean
$overflow=0; //counter for overflows
$paint=1; //draw graph yes
$asyval[0]='';//values for asymptotes
$asyval[1]='';
$asyval[2]='';
$derval='';//start value for the derivative within a function, e.g. D(x)

// read values
$form[0]=$formula1;//formula term 1 for display
$form[1]=$formula2;//formula term 2 for display
$form[2]=$formula3;//formula term 2 for display
$sint[0]=$sint1;//integral, derivative or f(x) of function 1
$sint[1]=$sint2;//integral, derivative or f(x) of function 2
$sint[2]=$sint3;//integral, derivative or f(x) of function 3
$col[0]=$col1;//color 1
$col[1]=$col2;//color 2
$col[2]=$col3;//color 3
$term[0]=$term1;//show term 1
$term[1]=$term2;//show term 2
$term[2]=$term3;//show term 3
$con[0]=$con0;//connection term 1
$con[1]=$con1;//connection term 1
$con[2]=$con2;//connection term 1

// replace Q with substitution in formula terms
for($i=0;$i<3;$i++) 
	$form[$i]=str_replace('Q','('.$qq.')',$form[$i]);

// definition and result range
// and +C for integrals
if(strlen(strval($ta1))==0) $ta1=-999999;
if(strlen(strval($ta2))==0) $ta2=999999;
if(strlen(strval($tb1))==0) $tb1=-999999;
if(strlen(strval($tb2))==0) $tb2=999999;
if(strlen(strval($tc1))==0) $tc1=-999999;
if(strlen(strval($tc2))==0) $tc2=999999;
$tdef1[0]=str_replace(",",".",$ta1);
$tdef1[1]=str_replace(",",".",$tb1);
$tdef1[2]=str_replace(",",".",$tc1);
$tdef2[0]=str_replace(",",".",$ta2);
$tdef2[1]=str_replace(",",".",$tb2);
$tdef2[2]=str_replace(",",".",$tc2);
$cint[0]=$cint1;
$cint[1]=$cint2;
$cint[2]=$cint3;
for($i=0;$i<3;$i++) { //constants as from-to range and +C
	$tdef1[$i]=str_replace('pi',M_PI,$tdef1[$i]);
	$tdef1[$i]=str_replace('e',M_E,$tdef1[$i]);
	$tdef1[$i]=str_replace('sq2',M_SQRT2,$tdef1[$i]);
	$tdef1[$i]=str_replace('go','1.6180339887499',$tdef1[$i]);
	$tdef1[$i]=str_replace('d','4.669201609103',$tdef1[$i]);
	$tdef2[$i]=str_replace('pi',M_PI,$tdef2[$i]);
	$tdef2[$i]=str_replace('e',M_E,$tdef2[$i]);
	$tdef2[$i]=str_replace('sq2',M_SQRT2,$tdef2[$i]);
	$tdef2[$i]=str_replace('go','1.6180339887499',$tdef2[$i]);
	$tdef2[$i]=str_replace('d','4.669201609103',$tdef2[$i]);
	$cint[$i]=str_replace(',','.',$cint[$i]);
	$cint[$i]=str_replace('pi',M_PI,$cint[$i]);
	$cint[$i]=str_replace('e',M_E,$cint[$i]);
	$cint[$i]=str_replace('sq2',M_SQRT2,$cint[$i]);
	$cint[$i]=str_replace('go','1.6180339887499',$cint[$i]);
	$cint[$i]=str_replace('d','4.669201609103',$cint[$i]);
	if(!is_numeric($tdef1[$i]) || !is_numeric($tdef2[$i]))
		die(); //security check before eval
	eval('$tdef1[$i] = $tdef1[$i];');
	eval('$tdef2[$i] = $tdef2[$i];');
}

// create empty image and define colors
$img=imagecreatetruecolor($width,$height);
imageantialias($img,$anti);
$color[0]=imagecolorallocate($img,0,0,190);//blue 1
$color[1]=imagecolorallocate($img,0,0,255);//blue 2
$color[2]=imagecolorallocate($img,99,128,255);//blue 3
$color[3]=imagecolorallocate($img,190,0,0);//red 1
$color[4]=imagecolorallocate($img,255,0,0);//red 2
$color[5]=imagecolorallocate($img,190,190,0);//yellow 1
$color[6]=imagecolorallocate($img,255,255,0);//yellow 2
$color[7]=imagecolorallocate($img,0,90,0);//green 1
$color[8]=imagecolorallocate($img,0,180,0);//green 2
$color[9]=imagecolorallocate($img,0,255,0);//green 3
$color[10]=imagecolorallocate($img,80,80,80);//grey 1
$color[11]=imagecolorallocate($img,127,127,127);//grey 2
$color[12]=imagecolorallocate($img,190,190,190);//grey 3
$color[13]=imagecolorallocate($img,0,0,0);//black
$color[14]=imagecolorallocate($img,255,255,255);//white
$color[15]=imagecolorallocate($img,65,226,213);//turquoise
$color[16]=imagecolorallocate($img,238,129,238);//violet
$color[17]=imagecolorallocate($img,131,0,131);//purple
$color[18]=imagecolorallocate($img,164,40,41);//brown 1
$color[19]=imagecolorallocate($img,0,255,255);//cyan
$color[20]=imagecolorallocate($img,100,149,237);//blue 4
$color[21]=imagecolorallocate($img,176,196,222);//blue 5
$color[22]=imagecolorallocate($img,0,255,127);//green 4
$color[23]=imagecolorallocate($img,144,238,144);//green 5
$color[24]=imagecolorallocate($img,128,128,0);//green 6
$color[25]=imagecolorallocate($img,220,220,220);//grey 4
$color[26]=imagecolorallocate($img,189,183,107);//brown 2
$color[27]=imagecolorallocate($img,139,69,19);//brown 3
$color[28]=imagecolorallocate($img,255,69,0);//orange
$color[29]=imagecolorallocate($img,188,143,143);//red 3
$color[30]=imagecolorallocate($img,240,128,128);//red 4
$color[31]=imagecolorallocate($img,75,0,130);//violet 2
$color[32]=imagecolorallocate($img,186,85,211);//violet 3
$color[33]=imagecolorallocate($img,123,104,238);//violet 4
$color[34]=imagecolorallocate($img,255,0,255);//violet 5
$color[35]=imagecolorallocate($img,219,112,147);//violet 6
$color[36]=imagecolorallocate($img,220,20,60);//violet 7
$color[37]=imagecolorallocate($img,240,255,255);//blue 6
$color[38]=imagecolorallocate($img,110,100,90);//transparent
imagecolortransparent($img,$color[38]);
imagefill ($img,0,0,$color[$bg]);

$single=0; //we don't want to compute a single value, but the whole graph
include 'init.php';

// start values for lines and caption
$rulex=$rulex2-$rulex1;
$ruley=$ruley2-$ruley1;
$startx=round($height/$ruley*$ruley2);
$starty=round($width/$rulex*(-$rulex1));
if ($startx<0) $startx=0;
if ($startx>=$height) $startx=$height-1;
if ($starty<0) $starty=0;
if ($starty>=$width) $starty=$width-1;

// reticule and axis lines, caption and dashes
function drawlines() {
	global $width, $height, $gridx, $gridy, $startx, $starty, $color, $intervalsx, $intervalsy, $rulex, $rulex1, $ruley, $ruley2, $linex, $liney, $grid, $dashes, $deci, $numbers, $logsk, $linec, $capt, $gapc, $lines, $img;

	// draw reticule lines
	if($grid) {
		$stepx=intval($width/$gridx+.5);
		for($i=0;$i<=$stepx*$gridx ;$i+=$stepx) {
			if($i>0) { //reticule lines x
				if ($i==$starty+1 || $i==$starty-1)
					$i=$starty;
				imageline ($img,$i,0,$i,$height-1,$color[$linec]);
			}
		}
		$stepy=intval($height/$gridy+.5);
		for($i=0;$i<=$stepy*$gridy ;$i+=$stepy) {
			if ($i>0) { //reticule lines y
				if ($i==$startx+1 || $i==$startx-1)
					$i=$startx;
				imageline ($img,0,$i,$width-1,$i,$color[$linec]);
			}
		}
	}
	
	// caption x-axis
	$count=-1;
	$stepx=round($width/$intervalsx);
	for($i=0;$i<=$stepx*$intervalsx ;$i+=$stepx) {
		$gap=0;
		++$count;
		if($dashes && $i>0) { //dashes x
			if ($i==$starty+1 || $i==$starty-1)
				$i=$starty;
			imageline ($img,$i,min($startx,$height)+$linex+1,$i,min($startx,$height)-$linex,$color[$capt]);
		}
		$value=$rulex1+$count*$rulex/$intervalsx;
		$value=round($value,$deci);
		$gap+=strlen($value)*3;
		if ($value && $count && $i!=$stepx*$intervalsx) { //labels x
			if ($startx<$height/2)
				$align=15;
			else
				$align=-15;
			if ($numbers)
				imagestring ($img,3,$i-$gap,min($startx,$height)+$align-$linex,$value,$color[$capt]);
		}
	}
	if($numbers)
		imagestring ($img,4,$width-15,min($startx,$height)+$align-$linex,"x",$color[$capt]);
	
	// caption y-axis
	$count=0;
	$stepy=round($height/$intervalsy);
	for($i=$stepy;$i<=$stepy*$intervalsy ;$i+=$stepy) {
		++$count;
		if ($dashes && $i>0) { //dashes y
			if ($i==$startx+1 || $i==$startx-1)
				$i=$startx;
			imageline ($img,max($starty,0)+$liney+1,$i,max($starty,0)-$liney,$i,$color[$capt]);
		}
		$value=$ruley2-$count*$ruley/$intervalsy;
		$gap+=strlen($value)*3;
		if ($value && $count && $i!=$stepy*$intervalsy) { //labels y
			if ($starty<=$width/2)
				$align=4;
			else
				$align=-30-strlen($value)*4;
			if(strval($logsk)=="M_E")
				$logsk=2.718281828459;
			if($logsk)
				$value=pow($logsk,$value);
			$value=round($value,$deci);
			$value=str_replace('E+','*10^',$value);
			if(substr($value,0,2)=="1*")
				$value=str_replace('1*','',$value);
			if ($numbers)
				imagestring ($img,3,max($starty,0)+$align+$liney,$i-6,$value,$color[$capt]);
		}
	}
	if($numbers)
		imagestring ($img,4,max($starty,0)+$align+$liney,5,"y",$color[$capt]);
	
	// draw axis lines
	if ($lines) {
		imageline ($img,0,$startx,$width-1,$startx,$color[$capt]); //horizontally
		imageline ($img,$starty,0,$starty,$height-1,$color[$capt]); //vertically
	}
}

// draw lines in background
if($bf==1)
	drawlines();

// draw gap at origin
if ($mid>0) {
	$middlex=-$rulex1/$rulex*$width;
	$middley=$ruley2/$ruley*$height;
	imagerectangle ($img,$middlex-$mid,$middley-$mid,$middlex+$mid,$middley+$mid,$color[$capt]);
	--$mid;
	if ($mid>0)
		imagefilledrectangle ($img,$middlex-$mid,$middley-$mid,$middlex+$mid,$middley+$mid,$color[$gapc]);
}

// draw graph
$derivative=''; //remember old value for derivative
$valyold=''; //remember old value for derivative
$derval='';
for ($j=0;$j<3;$j++) {
	$count=0; //count results
	if($asyval[$j])//draw asymptotes
		imageline ($img,$asyval[$j],0,$asyval[$j],$height-1,$color[$col[$j]]);
	else if ($formula[$j]!='') { //don't draw graph when function is empty
		$iter='';
		$iter2='';
		$istep=0;
		if(!$sint[$j] || !$logsk) { //no integral or derivative at a log scale
			$sum=0;
			$integral=0;
			$intplus=0; // +C at integral
			unset($x1);
			unset($y1);
			for ($i=0;$i<=$width;$i++) {
				$valx=$rulex1+$i*$rulex/$width;
				if($valx>=$tdef1[$j] && $valx<=$tdef2[$j]) { //draw over definition range
					$valy=graph($valx,$formula[$j]);
					if($sint[$j]==2 && is_numeric($valy)) { //integrate
						$integral+=$valy/$width*$rulex;
						$valy=$integral;
						if($cint[$j])
							$intplus=$cint[$j]*$width/$rulex;
					}
					else if($sint[$j]==1 && is_numeric($valy)) { //derivate
						$valyold=$valy;
						if(is_numeric($derivative)) {
							$valy-=$derivative;
							$valy*=$width/$rulex;
						}
						if(!is_numeric($derivative))
							$valy=NULL;
						$derivative=$valyold;
					}
					if ($valy==999999) {
						++$overflow;
						++$count;
						if($overflow>9) {
							if($errors) {
								imagefilledrectangle ($img,$height/2-85,80+$j*40,$height/2-85+9*strlen($text2)+15,95+$j*40,$color[$bg]);
								imagestring ($img,5,$height/2-80,80+$j*40,$text2.($j+1),$color[$col[$j]]);
							}
							next;
						}
					}
					$set1=$height-1-intval(($valy-$ruley1)/$ruley*$height-.5);
					$set2=$height-1-intval(($valy-$ruley1)/$ruley*$height+.5);
					$set=round(($set1+$set2)/2);
					if (strlen($valy)) {
						if (!isset($x1)) $x1=$i;
						if (!isset($y1)) $y1=$set;
						if(!(($y1>$height && $set<0) || ($y1<0 && $set>$height))) {
							if($con[$j]==0 && (abs($y1-$set)<$height/3 || !$pol)) //connect two dots, but don't connect poles (a pole is defined here as when two dots have a further vertical distance than 1/3 of the image height. Of course this is a bit problematic, but I didn't find a better way so far.)
								imageline($img,$x1,$y1-$intplus,$i,$set-$intplus,$color[$col[$j]]);
							else if($con[$j]==1) //only draw dots
								imagesetpixel($img,$x1,$y1-$intplus,$color[$col[$j]]);
							else if($con[$j]==2) //fill graph inside
								imageline($img,$x1,$startx,$x1,$set-$intplus,$color[$col[$j]]);
							else if($con[$j]==3) { //fill graph outside
								imageline($img,$x1,0,$x1,min($startx,$set-$intplus),$color[$col[$j]]);
								imageline($img,$x1,$height,$x1,max($startx,$set-$intplus),$color[$col[$j]]);
							}
						}
						$x1=$i;
						$y1=$set;
						++$count;
					} else { //don't connect definition gaps
						unset($x1);
						unset($y1);
					}
				}
			}
		}
		unset($sumres);
	} else
		++$count;
	// error message at result overflows or when no result found
	if(!$count && $errors && !$asyval[$j] && !$bracketerror[$j]){
		imagefilledrectangle ($img,$height/2-85,80+$j*40,$height/2-85+9*max(strlen($text3),strlen($text4))+10,115+$j*40,$color[$bg]);
		imagestring ($img,5,$height/2-80,80+$j*40,$text3,$color[$col[$j]]);
		imagestring ($img,5,$height/2-80,100+$j*40,$text4.($j+1),$color[$col[$j]]);
	}
	// bracket errors
	if($bracketerror[$j] && $errors) {
		imagefilledrectangle ($img,$height/2-85,80+$j*40,$height/2-85+9*strlen($text5)+15,95+$j*40,$color[$bg]);
		imagestring ($img,5,$height/2-80,80+$j*40,$text5.($j+1),$color[$col[$j]]);
	}
}

// draw lines in foreground
if($bf==2)
	drawlines();

// draw function terms
for($i=0;$i<3;$i++) {
	if($form[$i]!='' && $term[$i]){
		if($i==0)
			$term1="f";		
		else if($i==1)
			$term1="g";
		else
			$term1="h";
		if ($sint[$i]==2) {
			$form[$i]=strtoupper($term1).'(x)=S['.$form[$i].']';
			if($cint[$i]>0)
				$form[$i].='+';
			if ($cint[$i])
				$form[$i].=$cint[$i];
		}
		else if ($sint[$i]==1)
			$form[$i]=$term1."'(x)=[".$form[$i]."]'";
		else
			$form[$i]=$term1.'(x)='.$form[$i];
		if(strlen($form[$i])<$width/9) {
			imagefilledrectangle ($img,5,15*($i+1)-10,9*strlen($form[$i])+10,15*($i+1)+5,$color[$bg]);
			imagestring ($img,5,10,15*($i+1)-10,$form[$i],$color[$col[$i]]);
		} else {//reduce font size if term is too long
			imagefilledrectangle ($img,5,15*($i+1)-10,5*strlen($form[$i])+10,15*($i+1)+5,$color[$bg]);
			imagestring ($img,1,10,15*($i+1)-6,$form[$i],$color[$col[$i]]);
		}
	}
}

// draw frame
if ($frame)
	imagerectangle ($img,0,0,$width-1,$height-1,$color[$capt]);

// make image
if($gamma!=1) imagegammacorrect ($img,1,$gamma);
if($bri) imagefilter($img,IMG_FILTER_BRIGHTNESS,$bri);
if($cont) imagefilter($img,IMG_FILTER_CONTRAST,$cont);
if($emb) imagefilter($img,IMG_FILTER_EMBOSS);
if($blur) imagefilter($img,IMG_FILTER_GAUSSIAN_BLUR);
if($neg) imagefilter($img,IMG_FILTER_NEGATE);
if($gray) imagefilter($img,IMG_FILTER_GRAYSCALE);
if($mean) imagefilter($img,IMG_FILTER_MEAN_REMOVAL);
if($edge) imagefilter($img,IMG_FILTER_EDGEDETECT);
if($rotate) $img=imagerotate($img,-$rotate,$color[$bg]);

// output
if($filetype==1)
	imagegif($img);
else if($filetype==2)
	imagejpeg($img,NULL,90);
else
	imagepng($img,NULL,1);
?>