<?php
/*
#########################################################
#############   openPlaG 2.1: single.php   ##############
#########################################################
#############   written by Juergen Kummer   #############
#########################################################
##############   published under GNU GPL   ##############
#########################################################
Original source: http://rechneronline.de/function-graphs/
#########################################################
Copyright (C) 2008 Juergen Kummer

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

/*
This file feeds a given function with one single input value and writes the result.
It is hosted in an iframe on the main page.
*/
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title></title>
<meta http-equiv="expires" content="0" />
<meta name="robots" content="noindex,nofollow" />
<meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
<link rel="stylesheet" href="graph.css" type="text/css" />
</head>
<body style="margin:0px;padding:0px;background-color:#dedede">
<b>
<?php

// this is, if you have register_globals = OFF in your php.ini,
$c=$_POST['c'];
$qqsingle=$_POST['qqsingle'];
$single1=$_POST['single1'];
$inpval=$_POST['inpval'];

// transform formula and input value,
// to make it understandable by PHP
if(!$inpval) $inpval=0;
if(!$single1) $single1="";
$formula1=str_replace('phi','qqq',$single1);
$inpval=str_replace(',','.',$inpval);
$inpval=str_replace('pi',M_PI,$inpval);
$inpval=str_replace('e',M_E,$inpval);
$inpval=str_replace('sq2',M_SQRT2,$inpval);
$inpval=str_replace('go',1.6180339887499,$inpval);
$inpval=str_replace('d',4.6692016091030,$inpval);
if(!is_numeric($inpval))
	die('Error'); //security check before eval
eval("\$inpval = $inpval;");

// substituted formulas should be calculable too
$qq=$qqsingle;

$single=1; //we don't want to compute the whole graph, only a single value
include 'init.php';

// do the calculation and echo the result
$erg=graph($inpval,$formula[0]);
if($erg==999999) echo $text2;
else if($bracketerror[0]) echo $text5;
else echo $erg;

?>
</b>
</body>
</html>